<?php

namespace App\Exceptions;

use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Illuminate\Support\Facades\Http;
use Throwable;

class Handler extends ExceptionHandler
{
    /**
     * A list of the exception types that are not reported.
     *
     * @var array
     */
    protected $dontReport = [
        //
    ];

    /**
     * A list of the inputs that are never flashed for validation exceptions.
     *
     * @var array
     */
    protected $dontFlash = [
        'password',
        'password_confirmation',
    ];

    /**
     * Report or log an exception.
     *
     * @param  \Throwable  $exception
     * @return void
     *
     * @throws \Exception
     */
    public function report(Throwable $exception)
    {
        $this->reportError($exception);
        parent::report($exception);
    }

    /**
     * Render an exception into an HTTP response.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Throwable  $exception
     * @return \Symfony\Component\HttpFoundation\Response
     *
     * @throws \Throwable
     */
    public function render($request, Throwable $exception)
    {
        return parent::render($request, $exception);
    }

    private function reportError(Throwable $e){
        try {


            if(!$e->getMessage()){
                return;
            }

            if(strtolower($e->getMessage()) == 'not found'){
                //ignore
                return;
            }


            if($e->getMessage()){
                $url =   config('stag.backendUrl') . '/dev/reportPhpError';
                $headers['secret'] = 'superman';
                Http::asForm()
                    ->withHeaders($headers)
                    ->post($url, [
                        'data'=>'FE2: '.$e->getMessage().'URL: '.url()->current(),
                        'secret' => 'superman'
                    ])
                    ->json();
            }
        }catch(\Exception $e){
            //do nothing
        }
    }
}
